

unit BOM_Filter;
// ---------------------------------------------
// Automated generated 06.09.2016 20:40:19
// Warning: 
//   if you rerun the tool, your changes are lost
// ---------------------------------------------


{$IFDEF FPC}
{$mode objfpc}{$H+}
{$ENDIF}


interface


uses
  SysUtils, Classes
  ,tiObject
  ,tiAutoMap
  ,tiOPFManager
  ,tiVisitorDB
  ,tiVisitorCriteria
  ,tiCriteria
  ,tiSQLParser
  ,mapper
  ;

type


  // ---------------------------------------------
  // Generated Classes
  // ---------------------------------------------


  { Generated Class: TFilter}

{ TFilter
     InputFields  : The fieldnumber where  Input is coming,
                      colon for seperation. Only numbers
                      based on zero are allowed eg. 0,1,3,5
                      Empty string are ok if the value is calculated
     Filter :       The name of the filter, used for the factory
                      Must have to be a valid content (Internally set and used)
     OutputFields : The fieldnumber where  the output is going to,
                      colon for seperation. Only numbers
                      based on zero are allowed eg. 0,1,3,5
                      if the same number as in input is used, the content
                      is overwritten. Must have to be a valid content.
     Params :       Parameter for the filter, can be also a list seperated
                      with colon. Empty string are ok
  }
  TFilter = class(TtiObject)
  protected
    FInputFields: String;
    FFilter: String;
    FOutputFields: String;
    FParams: String;
    FRemark: String;
    procedure   SetInputFields(const AValue: String); virtual;
    procedure   SetFilter(const AValue: String); virtual;
    procedure   SetOutputFields(const AValue: String); virtual;
    procedure   SetParams(const AValue: String); virtual;
    procedure   SetRemark(const AValue: String); virtual;
  public
    constructor Create; override;
    constructor CreateNew(const AOwner: TtiObject; const ADatabaseName: string = ''; const APersistenceLayerName: string = ''); override;
    constructor CreateNew(const ADatabaseName: string = ''; const APersistenceLayerName: string = ''); override;
    function    CheckParams: Boolean; virtual;
    function    Execute(InListe : TStrings; OutListe : TStrings): Boolean; virtual;
    procedure   Read; override;
    procedure   Save; override;
  published
    property    InputFields: String read FInputFields write SetInputFields;
    property    Filter: String read FFilter write SetFilter;
    property    OutputFields: String read FOutputFields write SetOutputFields;
    property    Params: String read FParams write SetParams;
    property    Remark: String read FRemark write SetRemark;
  end;
  
  { List of TFilter.  TtiMappedFilteredObjectList descendant. }
  TFilterList = class(TtiMappedFilteredObjectList)
  protected
    procedure   SetItems(i: integer; const AValue: TFilter); reintroduce;
    function    GetItems(i: integer): TFilter; reintroduce;
  public
    property    Items[i:integer] : TFilter read GetItems write SetItems;
    procedure   Add(AObject: TFilter); reintroduce;
    procedure   Read; override;
    procedure   Save; override;
    { Return count (1) if successful. }
    function    FindByOID(const AOID: string): integer;
  end;
  
  { Read Visitor for TFilter }
  TFilter_Read = class(TtiVisitorSelect)
  protected
    function    AcceptVisitor: Boolean; override;
    procedure   Init; override;
    procedure   SetupParams; override;
    procedure   MapRowToObject; override;
  end;
  
  { Create Visitor for TFilter }
  TFilter_Create = class(TtiVisitorUpdate)
  protected
    function    AcceptVisitor: Boolean; override;
    procedure   Init; override;
    procedure   SetupParams; override;
  end;
  
  { Update Visitor for TFilter }
  TFilter_Update = class(TtiVisitorUpdate)
  protected
    function    AcceptVisitor: Boolean; override;
    procedure   Init; override;
    procedure   SetupParams; override;
  end;
  
  { Delete Visitor for TFilter }
  TFilter_Delete = class(TtiVisitorUpdate)
  protected
    function    AcceptVisitor: Boolean; override;
    procedure   Init; override;
    procedure   SetupParams; override;
  end;
  
  { List Read Visitor for TFilterList }
  TFilterList_Read = class(TtiVisitorSelect)
  protected
    function    AcceptVisitor: Boolean; override;
    procedure   Init; override;
    procedure   MapRowToObject; override;
  end;
  

  { Visitor Manager Registrations }
  procedure RegisterVisitors;

  { Register Auto Mappings }
  procedure RegisterMappings;


implementation


uses
  tiUtils
  ,tiLog
  , FACTORY_Filter
  , uFilter
  ;

procedure RegisterMappings;
begin
  { Automap registrations for TFilter }
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter, 
    'Filters', 'OID', 'FilterID', [pktDB]);
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter,
    'Filters','InputFields', 'InputFields');
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter,
    'Filters','Filter', 'Filter');
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter,
    'Filters','OutputFields', 'OutputFields');
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter,
    'Filters','Params', 'Params');
  GTIOPFManager.ClassDBMappingMgr.RegisterMapping(TFilter,
    'Filters','Remark', 'Remark');
  GTIOPFManager.ClassDBMappingMgr.RegisterCollection(TFilterList, TFilter);
  
end;

procedure RegisterVisitors;
begin
  { NOTE: The most reliable order of registering visitors are
          Read, Delete, Update, Create }
  GTIOPFManager.VisitorManager.RegisterVisitor('LoadFilterList', TFilterList_Read);
  GTIOPFManager.VisitorManager.RegisterVisitor('LoadFilter', TFilter_Read);
  GTIOPFManager.VisitorManager.RegisterVisitor('SaveFilter', TFilter_Delete);
  GTIOPFManager.VisitorManager.RegisterVisitor('SaveFilter', TFilter_Update);
  GTIOPFManager.VisitorManager.RegisterVisitor('SaveFilter', TFilter_Create);
  
end;

procedure TFilter.SetInputFields(const AValue: String);
begin
  if FInputFields = AValue then
    Exit;
  FInputFields := AValue;
end;

procedure TFilter.SetFilter(const AValue: String);
begin
  if FFilter = AValue then
    Exit;
  FFilter := AValue;
end;

procedure TFilter.SetOutputFields(const AValue: String);
begin
  if FOutputFields = AValue then
    Exit;
  FOutputFields := AValue;
end;

procedure TFilter.SetParams(const AValue: String);
begin
  if FParams = AValue then
    Exit;
  FParams := AValue;
end;

procedure TFilter.SetRemark(const AValue: String);
begin
  if FRemark = AValue then
    Exit;
  FRemark := AValue;
end;

constructor TFilter.Create;
begin
  inherited Create;
  FRemark:='';
end;

constructor TFilter.CreateNew(const AOwner: TtiObject;
  const ADatabaseName: string; const APersistenceLayerName: string);
begin
  Inherited;
  Filter := 'FilterCopy';
end;

constructor TFilter.CreateNew(const ADatabaseName: string;
  const APersistenceLayerName: string);
begin
  Inherited;
  Filter := 'FilterCopy';
end;

function TFilter.CheckParams: Boolean;
begin
  // Do nothing here, is better than abstract
  Result := false;
end;

function TFilter.Execute(InListe: TStrings; OutListe: TStrings): Boolean;
begin
  // Do nothing here, is better than abstract
  Result := false;
end;

procedure TFilter.Read;
begin
  GTIOPFManager.VisitorManager.Execute('LoadFilter', self);
end;

procedure TFilter.Save;
begin
  GTIOPFManager.VisitorManager.Execute('SaveFilter', self);
end;

 {TFilterList }

procedure TFilterList.Add(AObject: TFilter);
begin
  inherited Add(AObject);
end;

function TFilterList.GetItems(i: integer): TFilter;
begin
  result := inherited GetItems(i) as TFilter;
end;

procedure TFilterList.Read;
begin
  GTIOPFManager.VisitorManager.Execute('LoadFilterList', self);
end;

procedure TFilterList.Save;
begin
  GTIOPFManager.VisitorManager.Execute('SaveFilter', self);
end;

procedure TFilterList.SetItems(i: integer; const AValue: TFilter);
begin
  inherited SetItems(i, AValue);
end;

function TFilterList.FindByOID(const AOID: string): integer;
begin
  if self.Count > 0 then
    self.Clear;
    
  Criteria.ClearAll;
  Criteria.AddEqualTo('FilterID', AOID);
  Read;
  result := Count;
end;

{ TFilter_Create }
function TFilter_Create.AcceptVisitor: Boolean;
begin
  result := (Visited is TFilter) and (Visited.ObjectState = posCreate);
  Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, Result], lsAcceptVisitor);
end;

procedure TFilter_Create.Init;
begin
  Query.SQLText :=
    'INSERT INTO Filters(' +
    ' FilterID, ' +
    ' InputFields, ' +
    ' Filter, ' +
    ' OutputFields, ' +
    ' Params, ' +
    ' Remark' +
    ') VALUES (' +
    ' :FilterID, ' +
    ' :InputFields, ' +
    ' :Filter, ' +
    ' :OutputFields, ' +
    ' :Params, ' +
    ' :Remark' +
    ') ';
end;

procedure TFilter_Create.SetupParams;
var
  lObj: TFilter;
begin
  lObj := TFilter(Visited);
  lObj.OID.AssignToTIQuery('FilterID',Query);
  Query.ParamAsString['InputFields'] := lObj.InputFields;
  Query.ParamAsString['Filter'] := lObj.Filter;
  Query.ParamAsString['OutputFields'] := lObj.OutputFields;
  Query.ParamAsString['Params'] := lObj.Params;
  Query.ParamAsString['Remark'] := lObj.Remark;
end;

{ TFilter_Update }
function TFilter_Update.AcceptVisitor: Boolean;
begin
  result := (Visited is TFilter) and (Visited.ObjectState = posUpdate);
  Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, Result], lsAcceptVisitor);
end;

procedure TFilter_Update.Init;
begin
  Query.SQLText :=
    'UPDATE Filters SET ' +
    ' InputFields = :InputFields, ' +
    ' Filter = :Filter, ' +
    ' OutputFields = :OutputFields, ' +
    ' Params = :Params, ' +
    ' Remark = :Remark ' +
    'WHERE FilterID = :FilterID' ;
end;

procedure TFilter_Update.SetupParams;
var
  lObj: TFilter;
begin
  lObj := TFilter(Visited);
  lObj.OID.AssignToTIQuery('FilterID',Query);
  Query.ParamAsString['InputFields'] := lObj.InputFields;
  Query.ParamAsString['Filter'] := lObj.Filter;
  Query.ParamAsString['OutputFields'] := lObj.OutputFields;
  Query.ParamAsString['Params'] := lObj.Params;
  Query.ParamAsString['Remark'] := lObj.Remark;
end;

{ TFilter_Read }
function TFilter_Read.AcceptVisitor: Boolean;
begin
  result := (Visited is TFilter) and ((Visited.ObjectState = posPK) OR (Visited.ObjectState = posClean));
  Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, Result], lsAcceptVisitor);
end;

procedure TFilter_Read.Init;
begin
  Query.SQLText :=
    'SELECT ' +
    ' FilterID, ' +
    ' InputFields, ' +
    ' Filter, ' +
    ' OutputFields, ' +
    ' Params, ' +
    ' Remark ' +
    'FROM Filters WHERE FilterID = :FilterID' ;
end;

procedure TFilter_Read.SetupParams;
var
  lObj: TFilter;
begin
  lObj := TFilter(Visited);
  lObj.OID.AssignToTIQuery('FilterID',Query);
end;

procedure TFilter_Read.MapRowToObject;
var
  lObj: TFilter;
begin
  lObj := TFilter(Visited);
  lObj.OID.AssignFromTIQuery('FilterID',Query);
  lObj.InputFields := Query.FieldAsString['InputFields'];
  lObj.Filter := Query.FieldAsString['Filter'];
  lObj.OutputFields := Query.FieldAsString['OutputFields'];
  lObj.Params := Query.FieldAsString['Params'];
  lObj.Remark := Query.FieldAsString['Remark'];
end;

{ TFilter_Delete }
function TFilter_Delete.AcceptVisitor: Boolean;
begin
  result := (Visited is TFilter) and (Visited.ObjectState = posDelete);
  Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, Result], lsAcceptVisitor);
end;

procedure TFilter_Delete.Init;
begin
  Query.SQLText := 
    'DELETE FROM Filters ' +
    'WHERE FilterID = :FilterID';
end;

procedure TFilter_Delete.SetupParams;
var
  lObj: TFilter;
begin
  lObj := TFilter(Visited);
  lObj.OID.AssignToTIQuery('FilterID',Query);
end;

{ TFilterList_Read }
function TFilterList_Read.AcceptVisitor: Boolean;
begin
  result := (Visited.ObjectState = posEmpty);
  Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, Result], lsAcceptVisitor);
end;

procedure TFilterList_Read.Init;
var
  lFiltered: ItiFiltered;
  lWhere: string;
  lOrder: string;
  lSQL: string;
begin
  if Supports(Visited, ItiFiltered, lFiltered) then
  begin
    if lFiltered.GetCriteria.HasCriteria then
      lWhere := ' WHERE ' + tiCriteriaAsSQL(lFiltered.GetCriteria)
    else
      lWhere := '';
    if lFiltered.GetCriteria.hasOrderBy then
      lOrder := tiCriteriaOrderByAsSQL(lFiltered.GetCriteria)
    else
      lOrder := '';
  end;
  
  lSQL :=
    'SELECT ' +
    ' FilterID, ' +
    ' InputFields, ' +
    ' Filter, ' +
    ' OutputFields, ' +
    ' Params, ' +
    ' Remark ' +
    'FROM  Filters %s %s ;';
  
  Query.SQLText := gFormatSQL(Format(lSQL, [lWhere, lOrder]), TFilter);
  
end;

procedure TFilterList_Read.MapRowToObject;
var
  lObj: TFilter;
  aInstanceName : String;
begin
  // Check if Filter is valid/registerd
  if not gFilterFactory.IsRegistered(Query.FieldAsString['Filter']) then
  begin
    Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, 'Not valid Data' ], lsDebug);
    exit; //==>
  end;
  aInstanceName := Query.FieldAsString['Filter'];
  lObj := gFilterFactory.CreateInstance(aInstanceName,Query.FieldAsString['InputFields'],Query.FieldAsString['OutputFields']);
  if lObj = nil then
  begin
    Log([ClassName, Visited.ClassName, Visited.ObjectStateAsString, 'Object is nil' ], lsDebug);
    exit; //==>
  end;
  lObj.OID.AssignFromTIQuery('FilterID',Query);
  lObj.InputFields := Query.FieldAsString['InputFields'];
  lObj.Filter := Query.FieldAsString['Filter'];
  lObj.OutputFields := Query.FieldAsString['OutputFields'];
  lObj.Params := Query.FieldAsString['Params'];
  lObj.Remark := Query.FieldAsString['Remark'];
  lObj.ObjectState := posClean;
  TtiObjectList(Visited).Add(lObj);
end;

initialization
  RegisterVisitors;
  RegisterMappings;


end.
