unit FACTORY_Filter;

{$mode objfpc}{$H+}

interface
  uses
    Classes, SysUtils
    , tiObject
    , BOM_Filter
    ;

type
{ TFilterFactory }

TFilterClass = class of TFilter;

TFilterFactory = class(TPerObjFactory)
private
public
  function CreateInstance(const pStrClassID: string; pInput: string='';
    pOutput: string=''): TFilter; reintroduce;
  function CreateNewInstance(const pStrClassID: string; pInput: string;
    pOutput: string; AOwner: TtiObject=nil): TFilter; reintroduce;
end;

function gFilterFactory : TFilterFactory ;


implementation
uses
    tiQuery
  , tiLog
;
var
  uFilterFactory : TFilterFactory ;

function gFilterFactory : TFilterFactory ;
begin
  if uFilterFactory = nil then
    uFilterFactory := TFilterFactory.Create ;
  result := uFilterFactory ;
end;

{ TFilterFactory }

function TFilterFactory.CreateInstance(const pStrClassID: string;
  pInput: string = ''; pOutput: string =''): TFilter;
begin
  Result := nil;
  if pStrClassID = '' then
    exit; //==>
  Result := TFilter( inherited CreateInstance( pStrClassID )) ;
  Result.Filter       := pStrClassID;
  Result.InputFields  := pInput;
  Result.OutputFields := pOutput;
  Log([ClassName, Result.Filter, pStrClassID ], lsDebug);
end;

function TFilterFactory.CreateNewInstance(const pStrClassID: string; pInput: string;
      pOutput: string; AOwner: TtiObject=nil): TFilter;
begin
  Result := nil;
  if pStrClassID = '' then
    exit; //==>
  Result := TFilter( inherited CreateNewInstance( pStrClassID , AOwner )) ;
  Result.Filter       := pStrClassID;
  Result.InputFields  := pInput;
  Result.OutputFields := pOutput;
  Log([ClassName, Result.Filter, pStrClassID ], lsDebug);
end;

finalization
  uFilterFactory.Free ;


end.

