program FRConverter;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  Forms, fr_main, fr_convert, LocalizedForms, ufrmeditHash, ufrmeditsearch
  { you can add units after this }
  , SysUtils
  , tiQuerySqldbSQLite3 // SQLite 3 with SqlDB is used
  , tiUtils
  , tiOPFManager
  , tiConstants
  , tiLog
  , tiLogToFile, FACTORY_Filter, SUPPORT_Filter, uFilter, ufrmInfo;

{$R *.res}

procedure StartLog;
var
  aFileName : String;
  i : Integer;
  LS : String;
begin
  // Log
  aFileName := tiSwapExt(ParamStr(0),'log');
  gLog.RegisterLog(TtiLogToFile.CreateWithFileName(ExtractFilePath(aFileName),ExtractFileName(aFileName),True));
  gLog.SevToLog :=  [
    lsNormal
    ,lsUserInfo
    ,lsObjCreation
    ,lsVisitor
    ,lsConnectionPool
    ,lsAcceptVisitor
    ,lsQueryTiming
    ,lsDebug
    ,lsWarning
    ,lsError
    ,lsSQL
    ];
  Log('Starting', lsNormal);
  GTIOPFManager.DefaultPersistenceLayerName := cTIPersistSqldbSQLite3;
  LS := '';
  for i := 0 to GTIOPFManager.PersistenceLayers.Count - 1 do
  begin
    if LS <> '' then
      LS := LS + cLineEnding;
    if Trim(GTIOPFManager.PersistenceLayers.Items[i].DBConnectionPools.DetailsAsString) = '' then
      LS := LS + 'Persistence layer: "'+ GTIOPFManager.PersistenceLayers.Items[i].PersistenceLayerName +
            '" loaded, but not connected to a database.'
    else
      LS := LS + GTIOPFManager.PersistenceLayers.Items[i].DBConnectionPools.DetailsAsString
  end;
  if LS <> '' then
    Log(LS, lsDebug)
  else
    Log('No persistence layers loaded', lsDebug);
end;



begin
  RequireDerivedFormResource:=True;
  Application.Initialize;
  StartLog;
  Application.CreateForm(TfrmFRMain, frmFRMain);
  Application.Run;
end.

