unit SUPPORT_Filter;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils
  ,BOM_Filter
  ,tiOPFManager
  ;

{ CreateTables }
procedure CreateTables;

{ DeleteTables }
procedure DeleteTables;


implementation
uses
    tiQuery,
    tiLog
    ;


procedure CreateTables;
var
  lMD : TtiDBMetaDataTable;
begin
  Log('BOM_Filter.CreateTables: Create Table in DB', lsDebug);

  // Create the needed tables
  lMD :=TtiDBMetaDataTable.Create;
  try
    lMD.AddInstance('FilterID', qfkString, 36);
    lMD.AddInstance('InputFields', qfkString, 255);
    lMD.AddInstance('Filter', qfkString, 255);
    lMD.AddInstance('OutputFields', qfkString, 255);
    lMD.AddInstance('Params', qfkString, 255);
    lMD.AddInstance('Remark', qfkString, 255);
    lMD.Name := 'Filters';
    gTIOPFManager.CreateTable(lMD);
  finally
    lMD.Free;
  end;
end;

procedure DeleteTables;
begin
  Log('BOM_Filter.DeleteTables: Delete Table Filters in DB', lsDebug);
  if GTIOPFManager.TableExists('Filters') then
    GTIOPFManager.DropTable('Filters');
end;

end.

