unit SUPPORT_Search;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils
  ,BOM_Search
  ,tiOPFManager
  ,mapper
  ;


{ CreateTables }
procedure CreateTables;

{ DeleteTables }
procedure DeleteTables;

implementation
uses
  tiQuery
  , tiLog
  ;


procedure CreateTables;
var
  lMD : TtiDBMetaDataTable;
begin
  Log('SUPPORT_Search.CreateTables: Create Table in DB', lsDebug);

  // Create the needed tables
  lMD :=TtiDBMetaDataTable.Create;
  try
    lMD.AddInstance('SearchID', qfkString, 36);
    lMD.AddInstance('SearchText', qfkString, 255);
    lMD.AddInstance('ResultText', qfkString, 255);
    lMD.AddInstance('Category', qfkString, 255);
    lMD.AddInstance('SubCategory', qfkString, 255);
    lMD.AddInstance('Remark', qfkString, 255);
    lMD.Name := 'Search';
    gTIOPFManager.CreateTable(lMD);
  finally
    lMD.Free;
  end;
end;

procedure DeleteTables;
begin
  Log('SUPPORT_Search.DeleteTables: Delete Table Search in DB', lsDebug);
  if GTIOPFManager.TableExists('Search') then
    GTIOPFManager.DropTable('Search');
end;



end.

