unit fr_main;

{ TODO 1 -oAndi -cZeichensatzfehler: Zeichensatzfehler bei der Suche im Textfile  }
{ TODO 3 -oAndi -cDateien : wenn die SQLite3.dll fehlt, so wird das nicht klar an den Benutzer kommuniziert }

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  LCLTranslator, LocalizedForms, ActnList, Menus,
  ComCtrls, XMLPropStorage, ExtCtrls, StdCtrls, Buttons, PairSplitter;

type

  { TfrmFRMain }
  // inherit from TLocalizedForm, .lfm file begins with "inherited" instead of "object"
  TfrmFRMain = class(TLocalizedForm)
    actGetFilename: TAction;
    actConvert: TAction;
    actEditSearch: TAction;
    actEditFilter: TAction;
    actEditHash: TAction;
    actCreateNewDatabase: TAction;
    actCreateNewDatabaseRaika: TAction;
    actCpyDirSel: TAction;
    actTestConvert: TAction;
    actSearchConfig: TAction;
    actLangEN: TAction;
    actLangDE: TAction;
    actQuit: TAction;
    actlFRMain: TActionList;
    BuGetFileName: TBitBtn;
    BuGetCpyDir: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    CBMakeCopy: TCheckBox;
    CBMakeBakup: TCheckBox;
    EDFileName: TEdit;
    EDCpyDir: TEdit;
    imglFRMain: TImageList;
    LblFileName: TLabel;
    LblCpyDir: TLabel;
    MainMenu1: TMainMenu;
    MemoInfo: TMemo;
    MenuItem1: TMenuItem;
    mnuSubConfiguration: TMenuItem;
    mnuConfigLoad: TMenuItem;
    mnuLangEnglisch: TMenuItem;
    mnuLangDeutsch: TMenuItem;
    mnuSubSprache: TMenuItem;
    mnuFileQuit: TMenuItem;
    mnuSubFile: TMenuItem;
    ODFileName: TOpenDialog;
    ODConfigName: TOpenDialog;
    PairSplitter2: TPairSplitter;
    PairSplitterSide3: TPairSplitterSide;
    PairSplitterSide4: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    SelCpyDirDialog: TSelectDirectoryDialog;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    XMLConfigMain: TXMLPropStorage;
    procedure actConvertExecute(Sender: TObject);
    procedure actCpyDirSelExecute(Sender: TObject);
    procedure actCreateNewDatabaseExecute(Sender: TObject);
    procedure actCreateNewDatabaseRaikaExecute(Sender: TObject);
    procedure actEditFilterExecute(Sender: TObject);
    procedure actEditHashExecute(Sender: TObject);
    procedure actEditSearchExecute(Sender: TObject);
    procedure actGetFilenameExecute(Sender: TObject);
    procedure actLangENExecute(Sender: TObject);
    procedure actLangDEExecute(Sender: TObject);
    procedure actQuitExecute(Sender: TObject);
    procedure actSearchConfigExecute(Sender: TObject);
    procedure actTestConvertExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MemoQuelleChange(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure XMLConfigMainRestoreProperties(Sender: TObject);
    procedure XMLConfigMainSaveProperties(Sender: TObject);
  private
    { private declarations }
    FActualConverter: string;
    FLastLang : string;
    BaseFileName : String;
    AppFileCfgName : String;
    procedure DoConfigSet;
    procedure DoViewFilesExecute;
    procedure SetActualConverter(AValue: string);
    procedure SetStatusPanel;
    function DoCopyAndBackupFile(ASrcFileName, ADestDirName: string;
      ABackup: Boolean; AOverwrite: Boolean=True; AMove: Boolean=False
  ): Boolean;
  protected
    procedure PrepareTranslation;
    procedure SelectLanguage(ALang: String);
    procedure UpdateTranslation(ALang: String); override;
  public
    { public declarations }
  published
    property LastLang: string read FLastLang write FLastLang;
    property ActualConverter: string read FActualConverter write SetActualConverter;
  end;

var
  frmFRMain: TfrmFRMain;

implementation

{$R *.lfm}

uses
  LazFileUtils, fr_convert, ufrmInfo;

resourcestring
   rStrMainCaption = 'AF Converter for CSV Files';

   rStractQuitCaption = 'Quit';
   rStractLangDECaption = 'Deutsch';
   rStractLangENCaption = 'English';
   rStractGetFilenameCaption = 'Search';
   rStractSearchConfigCaption = 'Load Configuration';
   rStractEditSearchCaption ='Edit Search';
   rStractEditHashCaption ='Edit Hash';
   rStractEditFilterCaption ='Edit Filter';
   rStractCreateNewDatabase = 'Create new Database';
   rStractGetCypDirCaption = 'Dest. Dir';

   rStrmnuSubFileCaption = 'File ';
   rStrmnuSubSpracheCaption = 'Language';
   rStrmnuSubConfiguration = 'Configuration';

   rStrLblFileNameCaption = 'Sourcefile';
   rStrLblCpyDirCaption = 'Destination directory';

   rStrODFileNameTitle = 'Open existing file';
   rStrODFileNameFilter1 = 'Comma seperated values files|*.csv';
   rStrODFileNameFilter2 = 'Text files|*.txt';
   rStrODFileNameFilter3 = 'All files|*.*';

   rStrODConfigNameTitle = 'Open existing configuration';
   rStrODConfigNameFilter1 = 'Configuration files|*.sq3';

   rStractGetFilenameNoFile = 'File not found';
   rStractCpyDirSelNoDir = 'Directory not valid or readonly';
   rStractSearchConfigNoFile = 'Configuration not found';
   rStractSearchConfigFileExist = 'Error: Configuration exists';

   rStrCBMakeCopyCaption = 'Move file to destination';
   rStrCBMakeBackupCaption = 'Backup file to destination';

   rStrStatusBar1PanelsItems1Text = 'Config :';

   rStrNoFileLoaded = 'No config loaded';

   rStrErrorEditFilter = 'Error in Editfilter';
   rStrErrorDBEditFilter = 'Error can not open database';
   rStrErrorEditHash = 'Error in Edithash';
   rStrErrorDBEditHash = 'Error can not open database';
   rStrErrorEditSearch = 'Error in Editsearch';
   rStrErrorDBEditSearch = 'Error can not open database';



{ TfrmFRMain }

procedure TfrmFRMain.actLangENExecute(Sender: TObject);
begin
   LastLang := 'en';
   SelectLanguage(LastLang);
end;

procedure TfrmFRMain.actConvertExecute(Sender: TObject);
begin
{ TODO -oAndi -cFinishing : Hauptroutinen richtig stellen, weg von Testroutinen }
  // Hier sollte alles rein

end;

procedure TfrmFRMain.actCpyDirSelExecute(Sender: TObject);
begin
  //
  if EDCpyDir.Caption = '' then
     SelCpyDirDialog.InitialDir:=ExtractFilePath(EDFileName.Caption);
   SelCpyDirDialog.FileName:= ''; //EDFileName.Caption;
   if SelCpyDirDialog.Execute then
   begin
     if LazFileUtils.DirectoryExistsUTF8(SelCpyDirDialog.FileName) and
        LazFileUtils.DirectoryIsWritable(SelCpyDirDialog.FileName) then
       EDCpyDir.Caption := SelCpyDirDialog.FileName
     else
       ShowMessage(rStractCpyDirSelNoDir);
   end;

end;

procedure TfrmFRMain.actCreateNewDatabaseExecute(Sender: TObject);
begin
   DisconnectFromDatabase(MemoInfo);
   // Erzeugen einer neuen Konfiguration
   if ActualConverter <> '' then
     ODConfigName.InitialDir:=ExtractFilePath(ActualConverter)
   else
     ODConfigName.InitialDir:=ExtractFilePath(ParamStr(0));
   ODConfigName.DefaultExt:='.sq3';
   ODConfigName.Filter:= rStrODConfigNameFilter1;
   ODConfigName.FileName:= '';
   if ODConfigName.Execute then
   begin
     if not LazFileUtils.FileExistsUTF8(ODConfigName.FileName) then
     begin
       CreateNewDatabase(ODConfigName.FileName,MemoInfo);
       ActualConverter := ODConfigName.FileName;
       DisconnectFromDatabase(MemoInfo);
     end
     else
     begin
       MemoInfo.Append(rStractSearchConfigFileExist);
       ShowMessage(rStractSearchConfigFileExist);
     end;
   end;
   SetStatusPanel;
end;

procedure TfrmFRMain.actCreateNewDatabaseRaikaExecute(Sender: TObject);
begin
  DisconnectFromDatabase(MemoInfo);
  // Erzeugen einer neuen Konfiguration
  if ActualConverter <> '' then
    ODConfigName.InitialDir:=ExtractFilePath(ActualConverter)
  else
    ODConfigName.InitialDir:=ExtractFilePath(ParamStr(0));
  ODConfigName.DefaultExt:='.sq3';
  ODConfigName.Filter:= rStrODConfigNameFilter1;
  ODConfigName.FileName:= '';
  if ODConfigName.Execute then
  begin
    if not LazFileUtils.FileExistsUTF8(ODConfigName.FileName) then
    begin
      CreateNewDatabase(ODConfigName.FileName,MemoInfo);
      ActualConverter := ODConfigName.FileName;
      DisconnectFromDatabase(MemoInfo);
      // Create the new entries
      if not ConnectToDatabase(ActualConverter,MemoInfo) then
      begin
        MemoInfo.Append('Error in DB open');
        exit; //==>
      end;
      CreateNewRaika;
      DisconnectFromDatabase(MemoInfo);
      // End create the new entries
    end
    else
    begin
      MemoInfo.Append(rStractSearchConfigFileExist);
      ShowMessage(rStractSearchConfigFileExist);
    end;
  end;
  SetStatusPanel;
end;

procedure TfrmFRMain.actEditFilterExecute(Sender: TObject);
begin
  if not ConnectToDatabase(ActualConverter,MemoInfo) then
  begin
    MemoInfo.Append(rStrErrorDBEditFilter);
    exit; //==>
  end;
  if not DoEditFilter then MemoInfo.Append(rStrErrorEditFilter);
  DisconnectFromDatabase(MemoInfo);
end;

procedure TfrmFRMain.actEditHashExecute(Sender: TObject);
begin
  if not ConnectToDatabase(ActualConverter,MemoInfo) then
  begin
    MemoInfo.Append(rStrErrorDBEditHash);
    exit; //==>
  end;
  if not DoEditHash then MemoInfo.Append(rStrErrorEditHash);
  DisconnectFromDatabase(MemoInfo);
end;

procedure TfrmFRMain.actEditSearchExecute(Sender: TObject);
begin
  if not ConnectToDatabase(ActualConverter,MemoInfo) then
  begin
    MemoInfo.Append(rStrErrorDBEditSearch);
    exit; //==>
  end;
  if not DoEditSearch then MemoInfo.Append(rStrErrorEditSearch);
  DisconnectFromDatabase(MemoInfo);
end;

procedure TfrmFRMain.actGetFilenameExecute(Sender: TObject);
begin
  if EDFileName.Caption <> '' then
    ODFileName.InitialDir:=ExtractFilePath(EDFileName.Caption)
  else
    ODFileName.InitialDir:=ExtractFilePath(ParamStr(0));
  ODFileName.DefaultExt:='.csv';
  ODFileName.Filter:= rStrODFileNameFilter1 +'|'
                        + rStrODFileNameFilter2 +'|'
                        + rStrODFileNameFilter3;
  ODFileName.FileName:= ''; //EDFileName.Caption;
  if ODFileName.Execute then
  begin
    if LazFileUtils.FileExistsUTF8(ODFileName.FileName) then
      EDFileName.Caption := ODFileName.FileName
    else
      ShowMessage(rStractGetFilenameNoFile);
  end;
end;

procedure TfrmFRMain.actLangDEExecute(Sender: TObject);
begin
   LastLang := 'de';
   SelectLanguage(LastLang);
end;

procedure TfrmFRMain.actQuitExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmFRMain.actSearchConfigExecute(Sender: TObject);
begin
  // Laden der vorhandenen Konfiguration
  if ActualConverter <> '' then
    ODConfigName.InitialDir:=ExtractFilePath(ActualConverter)
  else
    ODConfigName.InitialDir:=ExtractFilePath(ParamStr(0));
  ODConfigName.DefaultExt:='.sq3';
  ODConfigName.Filter:= rStrODConfigNameFilter1;
  ODConfigName.FileName:= '';
  if ODConfigName.Execute then
  begin
    if LazFileUtils.FileExistsUTF8(ODConfigName.FileName) then
      ActualConverter := ODConfigName.FileName
    else
      ShowMessage(rStractSearchConfigNoFile);
  end;
  SetStatusPanel;
end;

procedure TfrmFRMain.actTestConvertExecute(Sender: TObject);
var
  myForm : TfrmInfo;
begin
  if not ConnectToDatabase(ActualConverter,MemoInfo) then
    exit; //==>

  myForm := TfrmInfo.Create(nil);
  try
    MemoInfo.Clear;
    myForm.Show;
    DoConvert(MemoInfo, myForm.MemoQuelle,myForm.MemoZiel,EDFileName.Caption,0);
    if DoCopyAndBackupFile(EDFileName.Text,EDCpyDir.Text,CBMakeCopy.Checked,CBMakeBakup.Checked) then
      DoCopyAndBackupFile(ChangeFileExt(EDFileName.Text,'.exp.csv'),EDCpyDir.Text,CBMakeCopy.Checked,CBMakeBakup.Checked);
    ShowMessage('Finished');
    myForm.Hide;
  finally
    myForm.Free;
  end;
  DisconnectFromDatabase(MemoInfo);
end;

procedure TfrmFRMain.DoConfigSet;
begin
  // Laden der Grundkonfiguration beim Start
  BaseFileName := ExtractFilePath(ParamStr(0)) + ExtractFileName(ParamStr(0));
  AppFileCfgName := LazFileUtils.GetAppConfigFileUTF8(False, False, True);
  XMLConfigMain.FileName := AppFileCfgName;
  XMLConfigMain.Restore;
end;

procedure TfrmFRMain.DoViewFilesExecute;
begin
end;

// Führt die Sprachumschaltung durch, und alles was damit zusammenhängt
procedure TfrmFRMain.SelectLanguage(ALang: String);
begin
  // Edit controls auslesen
  PrepareTranslation;

  // Sprache umschalten
  SetDefaultLang(ALang);

  // FormatSettings umschalten
  UpdateFormatSettings(ALang);

  // BiDiMode anpassen (hier egal, wichtig für hebräische etc.)
  UpdateBiDiMode(ALang);

  // Spezielle Übersetzungsprozedur der Fenster aufrufen
  UpdateTranslation(ALang);

  // Neue Sprache im Menü markieren
  actLangDE.Enabled:= LastLang<>'de';
  actLangEN.Enabled:= LastLang<>'en';
  // Texte richtig setzen
  StatusBar1.Panels.Items[0].Text:= LastLang;
  Caption:= rStrMainCaption;
  // Texte für die Actions (Buttons etc.)
  actQuit.Caption:= rStractQuitCaption;
  actLangDE.Caption:= rStractLangDECaption;
  actLangEN.Caption:= rStractLangENCaption;
  actGetFilename.Caption:= rStractGetFilenameCaption;
  actSearchConfig.Caption:= rStractSearchConfigCaption;
  actEditSearch.Caption:=rStractEditSearchCaption;
  actEditHash.Caption:=rStractEditHashCaption;
  actEditFilter.Caption:=rStractEditFilterCaption;
  actCreateNewDatabase.Caption:= rStractCreateNewDatabase;
  actCpyDirSel.Caption:=rStractGetCypDirCaption;
  // Hauptmenü Texte
  mnuSubFile.Caption:= rStrmnuSubFileCaption;
  mnuFileQuit.Caption:= rStractQuitCaption;
  mnuSubSprache.Caption:= rStrmnuSubSpracheCaption;
  mnuSubConfiguration.Caption:= rStrmnuSubConfiguration;

  // Button und Labels Text
  BuGetFileName.Caption:= rStractGetFilenameCaption; // Sonst ist bei Standard der Button nicht richtig
  LblFileName.Caption:= rStrLblFileNameCaption;

  BuGetCpyDir.Caption:=rStractGetCypDirCaption;
  LblCpyDir.Caption:=rStrLblCpyDirCaption;

  CBMakeCopy.Caption:=rStrCBMakeCopyCaption;
  CBMakeBakup.Caption := rStrCBMakeBackupCaption;

  // Dialoge
  ODFileName.Title:= rStrODFileNameTitle;

  // STatusbar Texte und die Längen setzen
  SetStatusPanel;
end;

procedure TfrmFRMain.SetActualConverter(AValue: string);
begin
  if FActualConverter=AValue then Exit;
  FActualConverter:=AValue;
end;


procedure TfrmFRMain.FormCreate(Sender: TObject);
begin
  LastLang:= GetDefaultLang;
  if LastLang = '' then
    LastLang:= 'de';
  DoConfigSet;     // Setzen der Basiskonfiguration
  SelectLanguage(LastLang);  // Spracheinstellungen laden
end;

procedure TfrmFRMain.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TfrmFRMain.MemoQuelleChange(Sender: TObject);
begin

end;

procedure TfrmFRMain.Panel1Click(Sender: TObject);
begin

end;

procedure TfrmFRMain.Panel3Click(Sender: TObject);
begin

end;


procedure TfrmFRMain.PrepareTranslation;
begin
  // Wird vor der Sprachumschaltung aufgerufen
end;

procedure TfrmFRMain.SetStatusPanel;
var
  Dummy: String;
begin
  // STatusbar Texte und die Längen setzen
  StatusBar1.Panels.Items[0].Width:= Round(Canvas.TextWidth(LastLang) * 1.2);
  StatusBar1.Panels.Items[0].Text:=LastLang;
  StatusBar1.Panels.Items[1].Width:= Round(Canvas.TextWidth(
    rStrStatusBar1PanelsItems1Text) * 1.2);
  StatusBar1.Panels.Items[1].Text:=rStrStatusBar1PanelsItems1Text;
  if ActualConverter = '' then
    Dummy := rStrNoFileLoaded
  else
    Dummy := ActualConverter;
  StatusBar1.Panels.Items[2].Width:= Round(Canvas.TextWidth(Dummy) * 1.2);
  StatusBar1.Panels.Items[2].Text:=Dummy;
end;

{ TODO 1 -oAndi -cDateien : Es wird nicht immer beim Verschieben die Datei gelöscht }
function TfrmFRMain.DoCopyAndBackupFile(ASrcFileName, ADestDirName: string;
  ABackup: Boolean; AOverwrite: Boolean = True; AMove: Boolean=False): Boolean;
var
  DestFileName : string;
begin
  Result := false;
  // first checks
  if not FileExistsUTF8(ASrcFileName) then exit; //===>
  if not DirectoryExistsUTF8(ADestDirName) then exit; //===>
  if not DirectoryIsWritable(ADestDirName) then exit; //===>
  // Create destination filename
  DestFileName:= ExpandFileNameUTF8(ExtractFileName(ASrcFileName),ADestDirName);
  // Check for same name
  if SameFileName(ASrcFileName,DestFileName) then exit; //===>
  // Check if destination file exist
  if FileExistsUTF8(DestFileName) then
  begin
    // file is in destination
    if not AOverwrite then exit; //===>
    // Check if destination backup filename exists
    if ABackup then
    begin
      if FileExistsUTF8(ChangeFileExt(DestFileName,'.bak')) then
      begin
        if not AOverwrite then exit; //===>
      end;
      // Copy file to bak - overwrite if needed
      if not CopyFile( DestFileName, ChangeFileExt(DestFileName,'.bak'),
                       [cffOverwriteFile],false) then exit; //===>
    end;
  end;
  // Copy the orginalfile to the destination - overwrite if needed
  if not CopyFile( ASrcFileName, DestFileName,
                   [cffOverwriteFile],false) then exit; //===>
  // if we move, we have to delete the file in sourceposition
  if AMove then
    if not DeleteFileUTF8(ASrcFileName) then exit; //===>  ;
  Result:=true;
end;

// Wird nach der Sprachumschaltung aufgerufen
procedure TfrmFRMain.UpdateTranslation(ALang: String);
begin
  // Wird nach der Sprachumschaltung aufgerufen
  inherited UpdateTranslation(ALang);
end;

procedure TfrmFRMain.XMLConfigMainRestoreProperties(Sender: TObject);
begin
  LastLang := XMLConfigMain.DoReadString('Persistent','Language','en');
  ActualConverter := XMLConfigMain.DoReadString('Persistent','ActualConverter','');
end;

procedure TfrmFRMain.XMLConfigMainSaveProperties(Sender: TObject);
begin
  if LastLang <> '' then
    XMLConfigMain.DoWriteString('Persistent','Language',LastLang)
  else
    XMLConfigMain.DoWriteString('Persistent','Language','en');
  if ActualConverter <> '' then
    XMLConfigMain.DoWriteString('Persistent','ActualConverter',ActualConverter);
end;

end.

