unit ufrmeditfilterdetail;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls
  , BOM_Filter
  , tiModelMediator
  ;

type

  { TfrmEditFilterDetail }

  TfrmEditFilterDetail = class(TForm)
    buSave: TButton;
    buCancel: TButton;
    CBFilter: TComboBox;
    EInputFields: TEdit;
    EOutputFields: TEdit;
    EParams: TEdit;
    ERemark: TEdit;
    LBInputFields: TLabel;
    LBFilter: TLabel;
    LBOutputFields: TLabel;
    LBParams: TLabel;
    LBRemark: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FData : TFilter;
    FMediator: TtiModelMediator;
    procedure SetData(AValue: TFilter);
    procedure SetupMediators;
  public
    { public declarations }
    property Data : TFilter read FData write SetData;
  end;

function ShowEditFilterDetail(AData : TFilter):Boolean ;


implementation

uses
  tiObject,
  FACTORY_Filter;

{$R *.lfm}

function ShowEditFilterDetail(AData : TFilter):Boolean ;
var
  frm : TfrmEditFilterDetail;
begin
  frm := TfrmEditFilterDetail.Create(nil);
  try
    frm.Data:=AData;
    result:= frm.ShowModal = mrOK;
  finally
    frm.Free;
  end;
end;

{ TfrmEditFilterDetail }

procedure TfrmEditFilterDetail.FormCreate(Sender: TObject);
var
  i: Integer;
  aName : String;
begin
  CBFilter.Items.Clear;
  for i := 0 to (gFilterFactory.Count-1) do
  begin
    aName:=TPerObjClassMapping(gFilterFactory.Items[i]).PerObjAbsClassName;
    CBFilter.Items.Add(aName);
  end;
end;

procedure TfrmEditFilterDetail.SetData(AValue: TFilter);
begin
  if FData=AValue then Exit;
  FData:=AValue;
  SetupMediators;
end;

procedure TfrmEditFilterDetail.SetupMediators;
begin
  if not Assigned(FMediator) then
  begin
    FMediator := TtiModelMediator.Create(self);
    FMediator.AddProperty('InputFields', EInputFields);
    FMediator.AddProperty('Filter', CBFilter);
    FMediator.AddProperty('OutputFields', EOutputFields);
    FMediator.AddProperty('Params', EParams);
    FMediator.AddProperty('Remark', ERemark);
  end;
  FMediator.Subject := FData;
  FMediator.Active := True;
end;

end.

