unit ufrmeditsearchdetail;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons
  , BOM_Search
  , tiModelMediator
  ;

type

  { TfrmEditSearchDetail }

  TfrmEditSearchDetail = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    ERegex: TEdit;
    ERemark: TEdit;
    EText: TEdit;
    EKategorie: TEdit;
    ESubKategorie: TEdit;
    LbRegex: TLabel;
    LbRemark: TLabel;
    LbText: TLabel;
    LbKategorie: TLabel;
    LbSubKategorie: TLabel;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
  private
    FData: TSearch;
    FMediator: TtiModelMediator;
    FZeile: string;
    procedure SetData(AValue: TSearch);
    procedure SetupMediators;
    procedure SetZeile(AValue: string);
    { private declarations }
  public
    { public declarations }
    property Data: TSearch read FData write SetData;
    property Zeile : string read FZeile write SetZeile;
  end;


//// Show the form
function ShowEditSearchDetail(aData:TSearch; Zeile: string):TModalResult;

implementation

uses
  tiObject;


function ShowEditSearchDetail(aData: TSearch; Zeile: string): TModalResult;
var
  frm : TfrmEditSearchDetail;
begin
  Result:=mrNone;
  if not Assigned(aData) then
    exit; //-->>
  frm := TfrmEditSearchDetail.Create(nil);
  try
    frm.Data := aData;
    frm.Zeile:= Zeile;
    Result := frm.ShowModal;
  finally
    frm.Free;
  end;
end;

{$R *.lfm}

{ TfrmEditSearchDetail }

procedure TfrmEditSearchDetail.FormCreate(Sender: TObject);
begin
 //
end;

procedure TfrmEditSearchDetail.SetData(AValue: TSearch);
begin
  if FData=AValue then Exit;
  FData:=AValue;
  SetupMediators;
end;

procedure TfrmEditSearchDetail.SetupMediators;
begin

  if not Assigned(FMediator) then
  begin
    FMediator := TtiModelMediator.Create(self);
    FMediator.AddProperty('SearchText', ERegex);
    FMediator.AddProperty('ResultText', EText);
    FMediator.AddProperty('Category', EKategorie);
    FMediator.AddProperty('SubCategory', ESubKategorie);
    FMediator.AddProperty('Remark', ERemark);
  end;
  FMediator.Subject := FData;
  FMediator.Active := True;
end;

procedure TfrmEditSearchDetail.SetZeile(AValue: string);
begin
  if FZeile=AValue then Exit;
  Edit1.Text:=AValue;
  FZeile:=AValue;
end;


end.

