unit uImporter;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil,LazFileUtils, IDEWindowIntf, Forms, Controls,
  Graphics, Dialogs, ComCtrls, Menus, ActnList, StdActns, XMLPropStorage,
  StdCtrls, Buttons, Grids, DBGrids;

type

  { TFormConv }

  TFormConv = class(TForm)
    actGetFilename: TAction;
    actCompact: TAction;
    actGetDatabaseName: TAction;
    actFilterEdit: TAction;
    actHashEdit: TAction;
    actSearchImport: TAction;
    actSearchEdit: TAction;
    actLoadConfig: TAction;
    actSaveConfig: TAction;
    actTestload: TAction;
    ActionList1: TActionList;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Button1: TButton;
    BuTest: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    edDatabase: TEdit;
    FileExit1: TFileExit;
    ImageList1: TImageList;
    LBLDatabase: TLabel;
    lblSearch: TLabel;
    lblHash: TLabel;
    LBLFields: TLabel;
    MainMenu1: TMainMenu;
    memoInfo: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    SGSearch: TStringGrid;
    StatusBar1: TStatusBar;
    SGFields: TStringGrid;
    SGHash: TStringGrid;
    tsConfig: TTabSheet;
    tsMain: TTabSheet;
    XMLPropStorage1: TXMLPropStorage;
    procedure actCompactExecute(Sender: TObject);
    procedure actFilterEditExecute(Sender: TObject);
    procedure actGetDatabaseNameExecute(Sender: TObject);
    procedure actHashEditExecute(Sender: TObject);
    procedure actLoadConfigExecute(Sender: TObject);
    procedure actGetFilenameExecute(Sender: TObject);
    procedure actSaveConfigExecute(Sender: TObject);
    procedure actSearchEditExecute(Sender: TObject);
    procedure actSearchImportExecute(Sender: TObject);
    procedure actTestloadExecute(Sender: TObject);
    procedure BuTestClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tsConfigContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
  private
    { private declarations }
    BaseFileName : String ;
    AppDirCfgName : String;
    StartLine : Integer;
    function DoCompactConfig: Boolean;
    function DoConvert: Boolean;
    //function DoConvertTemp: Boolean;
    function DoLoadConfig: Boolean;
    function DoSaveConfig: Boolean;
    function FindHash(Hash : String):Integer;
    procedure StoreHash(Hash, FileName: string);
    procedure StringGridCompactRows(SG: TStringGrid);
  public
    { public declarations }
  end;

var
  FormConv: TFormConv;

implementation

uses uparser, UTextFileStream, MD5, RegExpr
  ,afhelper
  ,formSearchEdit
  ;
{$R *.lfm}

{ TFormConv }

procedure TFormConv.actGetFilenameExecute(Sender: TObject);
begin
  OpenDialog1.FileName:= Edit1.Caption;
  if OpenDialog1.Execute then
    Edit1.Caption := OpenDialog1.FileName;
end;

procedure TFormConv.actSaveConfigExecute(Sender: TObject);
var
  FileName : string;
begin
  DoSaveConfig;
end;

procedure TFormConv.actSearchEditExecute(Sender: TObject);
begin
  //gListManager.SearchList.Read;
  //if ShowEditSearch(gListManager.SearchList,'Dummy')=mrNone then
  //  ShowMessage('Error in ShowEditSearch');
  //gListManager.SearchList.Save;
end;

procedure TFormConv.actSearchImportExecute(Sender: TObject);
//var
//  FileName: String;
//  aData : TSearch;
//  i: Integer;
begin
  //if gListManager.SearchList.Count > 0 then
  //begin
  //  ShowMessage('in Search sind daten vorhanden - Abbruch');
  //  exit;
  //end;
  //gListManager.SearchList.Clear;
  //FileName := BaseFileName+'_SGSearch.txt';
  //if FileExists(FileName) then
  //  SGSearch.LoadFromCSVFile(FileName)
  //else
  //  begin
  //    // Default Daten einfügen
  //  end;
  //for i := 0 to (SGSearch.RowCount-1) do
  //begin
  //  aData := TSearch.CreateNew;
  //  aData.SearchText:=SGSearch.Cells[1,i];
  //  aData.ResultText:=SGSearch.Cells[2,i];
  //  aData.Category:=SGSearch.Cells[3,i];
  //  aData.SubCategory:=SGSearch.Cells[4,i];
  //  aData.ObjectState  := posCreate;
  //  gListManager.SearchList.Add(aData);
  //end;
  //gListManager.SearchList.Save;
end;

procedure TFormConv.actLoadConfigExecute(Sender: TObject);
begin
  DoLoadConfig;
end;

procedure TFormConv.actCompactExecute(Sender: TObject);
begin

end;

procedure TFormConv.actFilterEditExecute(Sender: TObject);
begin
  //gListManager.FilterList.Read;
  //if not ShowEditFilter(gListManager.FilterList) then
  //  ShowMessage('Error in ShowEditFilter');
  //gListManager.FilterList.Save;
end;

procedure TFormConv.actGetDatabaseNameExecute(Sender: TObject);
begin
  if edDatabase.Caption <> '' then
    OpenDialog1.FileName:= edDatabase.Caption;
  if OpenDialog1.Execute then
    edDatabase.Caption := OpenDialog1.FileName;
end;

procedure TFormConv.actHashEditExecute(Sender: TObject);
begin
  //gListManager.HashList.Criteria.ClearAll;
  //gListManager.HashList.Read;
  //if ShowEditHash(gListManager.HashList)=mrNone then
  //  ShowMessage('Error in ShowEditHash');
  //gListManager.HashList.Save;
end;

procedure TFormConv.actTestloadExecute(Sender: TObject);
begin
  memoInfo.Clear;
  memoInfo.Append('Starte Umwandlung');
  If not FileExists(Edit1.Caption) then
  begin
    memoInfo.Append('Datei nicht gefunden: ' + Edit1.Text);
    memoInfo.Append('Abbruch Umwandlung');
    exit;
  end;
  memoInfo.Append('Datei gefunden');
  memoInfo.Append('Lade Konfiguration');
  DoLoadConfig;
  memoInfo.Append('Umwandlung');
  DoConvert;
  memoInfo.Append('Verdichte Konfiguration');
  DoCompactConfig;
  memoInfo.Append('Speichere Konfiguration');
  DoSaveConfig;
  memoInfo.Append('Fertig');
end;

procedure TFormConv.BuTestClick(Sender: TObject);
begin
  //memoInfo.Clear;
  //memoInfo.Append('Starte Test');
  //DoConvertTemp;
  //memoInfo.Append('Fertig');
end;

procedure TFormConv.Button1Click(Sender: TObject);
begin
  DoCompactConfig;
end;

procedure TFormConv.FormCreate(Sender: TObject);
begin
  BaseFileName := ExtractFilePath(ParamStr(0)) + ExtractFileName(ParamStr(0));
  AppDirCfgName := LazFileUtils.GetAppConfigFileUTF8(False, False, True);
  { TODO 1 -oAndi -cFinishing : Erst wenn fertig aktivieren }
  //XMLPropStorage1.FileName := AppDirCfgName;
  //XMLPropStorage1.Restore;
  memoInfo.Clear;
end;

procedure TFormConv.FormDestroy(Sender: TObject);
begin
  //

end;

procedure TFormConv.tsConfigContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  memoInfo.Clear;
end;


function TFormConv.DoCompactConfig:Boolean;
begin
  // Compact the information (eg. remove unused rows)
  StringGridCompactRows(SGFields);
  StringGridCompactRows(SGHash);
  StringGridCompactRows(SGSearch);
  Result := true;  // default for now
end;

function TFormConv.DoConvert: Boolean;
var
  TFS : TTextFileStream;
  TFSW : TTextFileStream;
  TS: TStringList;
  TSW: TStringList;
  OneLine : string;
  Hash : string;
  LineCount : Integer;
  FileName : string;
  SourceFSettings,DestFSettings: TFormatSettings;
  FieldCnt : integer;
  RegexObj: TRegExpr;
  strTemp : String;
  SearchCnt : Integer;
  strTemp1 : String;
  tmpI : Integer;
  RegexFound: Boolean;
  FormSearchEdit: TFormSearchEdit;
  mrResult: Integer;
begin
  Result := false;
  //
  FileName := Edit1.Text;
  StartLine:=0;
  SourceFSettings:=FormatSettings;
  SourceFSettings.DecimalSeparator:=',';
  SourceFSettings.ThousandSeparator:='.';
  DestFSettings:=FormatSettings;
  DestFSettings.DecimalSeparator:='.';
  DestFSettings.ThousandSeparator:=' ';
  // Check prerequisites
  if FileName = '' then begin ShowMessage('FileName not set'); exit; end;
  if not FileExists(FileName) then begin ShowMessage('File not found:' + FileName ); exit; end;
  // Check database
  if edDatabase.Text = '' then begin ShowMessage('Database Name not set'); exit; end;
  if not FileExists(edDatabase.Text) then begin ShowMessage('Database not found:' + edDatabase.Text ); exit; end;
  // All Ok
  TS:= TStringList.Create();
  TFS:= TTextFileStream.Create(FileName,fmOpenRead);
  TFSW:= TTextFileStream.Create(ChangeFileExt(FileName,'.exp.csv'),fmCreate);
  TSW := TStringList.Create();
  try
    LineCount := 0;
    while (not TFS.Eof) do
    begin
      inc(LineCount);
      if ((LineCount mod 10) = 0) then memoInfo.Append('Process line: '+IntToStr(LineCount));
      OneLine:= TFS.ReadLn;
      // Skip over line if startline not reached
      if (LineCount <= StartLine) then
      begin
        memoInfo.Append('Skip line: '+IntToStr(LineCount));
        Continue;
      end;
      // If line is empty, we skip this line
      if OneLine = '' then
      begin
        memoInfo.Append('Empty line: '+IntToStr(LineCount) + ' skipping');
        Continue;
      end;
      // Make Hash
      Hash := LowerCase(MDPrint(MDString(OneLine, MD_VERSION_5)));
      if FindHash(Hash) >= 0 then
      begin
        memoInfo.Append('Duplicated line: '+IntToStr(LineCount) + ' skipping');
        Continue;
      end;
      // Line to process
      ParseDelimitedText(OneLine,';','"',TS);
      // Linelength correct ?
      if TS.Count <> 7 then
      begin
        memoInfo.Append('Linelenght incorrect ('+ IntToStr(TS.Count) +') line: '+IntToStr(LineCount) + ' skipping');
        Continue;
      end;
      // Create the Outputstring
      TSW.Clear;
      for FieldCnt:=0 to 11 do
        TSW.Add('');
      // Process the fields
      for FieldCnt := 0 to TS.Count-1 do
      begin
        tmpI:= TSW.Count;
        tmpI := TS.Count;
        case FieldCnt of
          0 : TSW[0] := TS[0]; // First Line is Date -> no Convertion
          1 : begin
                TSW[1] := TS[1];
                // We have to Search for terms to generate Text, Categorie, SubCategorie
                RegexFound:=false;
                RegexObj := TRegExpr.Create;
                try
                  repeat
                    for SearchCnt := 0 to SGSearch.RowCount-1 do
                    begin
                      strTemp:= '.*'+ SGSearch.Rows[SearchCnt].ValueFromIndex[1] +'.*';
                      if strTemp = '.*.*' then continue;
                      RegexObj.Expression:=strTemp;
                      strTemp1:=TS[1];
                      if RegexObj.Exec(strTemp1) then
                      begin
                        TSW[8]:=SGSearch.Rows[SearchCnt].ValueFromIndex[2];  // Text
                        TSW[9]:=SGSearch.Rows[SearchCnt].ValueFromIndex[3];  // Categorie
                        TSW[10]:=SGSearch.Rows[SearchCnt].ValueFromIndex[4]; // SubCategorie
                        RegexFound:=true;
                        break;
                      end;
                    end;
                    if not RegexFound then
                       begin
                         TSW[8]:='';
                         TSW[9]:='';
                         TSW[10]:='';
//                         ShowMessage('Not found '+ TS[1] );
                         FormSearchEdit := TFormSearchEdit.Create(self);
                         try
                           //FormSearchEdit.Database:=edDatabase.Text;
                           FormSearchEdit.BaseText:= TS[1];
                           FormSearchEdit.SearchText:='';
                           FormSearchEdit.ResultText:='';
                           FormSearchEdit.Category:='';
                           FormSearchEdit.SubCategory:='';
                           mrResult := FormSearchEdit.ShowModal;
                           if mrResult = mrOK then
                             begin
                               SGSearch.RowCount:= SGSearch.RowCount+1;
                               SGSearch.Rows[SGSearch.RowCount-1].Add('');
                               SGSearch.Rows[SGSearch.RowCount-1].Add(FormSearchEdit.SearchText);
                               SGSearch.Rows[SGSearch.RowCount-1].Add(FormSearchEdit.ResultText);
                               SGSearch.Rows[SGSearch.RowCount-1].Add(FormSearchEdit.Category);
                               SGSearch.Rows[SGSearch.RowCount-1].Add(FormSearchEdit.SubCategory);
                            end
                           else
                             if mrResult = mrAbort then
                               exit
                             else
                               RegexFound:=true;
                         finally
                           FormSearchEdit.Free;
                         end;
                       end;
                   until RegexFound;
                finally
                 RegexObj.Free;
                end;
              end;
          2 : TSW[2] := TS[2]; //  -> no Convertion;
          3 : begin
                StrFormat2StrFormat(TS[3],SourceFSettings,strTemp,DestFSettings);
                TSW[3] := strTemp;
              end;
          4 : TSW[4] := TS[4]; //  -> no Convertion;
          5 : TSW[5] := TS[5]; //  -> no Convertion;
          6 : TSW[6] := TS[6]; //  -> no Convertion;
        end;
      end;
      TSW[7] := Hash;
      // All Ok, store the Hash
      StoreHash(Hash, FileName);
      // Store Result
      strTemp := TSW.DelimitedText;
      TFSW.Write(strTemp[1], Length(strTemp));
      TFSW.Write(LineEnding, Length(LineEnding));
    end;
  finally
    TS.Free;
    TFS.Free;
    TFSW.Free;
  end;
end;

//function TFormConv.DoConvertTemp: Boolean;
//var
//  TFS : TTextFileStream;
//  TFSW : TTextFileStream;
//  TS: TStringList;
//  TSW: TStringList;
//  OneLine : string;
//  Hash : string;
//  LineCount : Integer;
//  FileName : string;
//  SourceFSettings,DestFSettings: TFormatSettings;
//  FieldCnt : integer;
//  RegexObj: TRegExpr;
//  strTemp : String;
//  SearchCnt : Integer;
//  strTemp1 : String;
//  tmpI : Integer;
//  RegexFound: Boolean;
//  FormSearchEdit: TFormSearchEdit;
//  mrResult: Integer;
//  Filters : TFilterList;
//  aFilter : TFilter;
//  aTiObjects : TtiObject;
//  aHash: THash;
//begin
//  Result := false;
//  FileName := Edit1.Text;
//  StartLine:=0;
//  // Check prerequisites
//  if FileName = '' then begin ShowMessage('FileName not set'); exit; end;
//  if not FileExists(FileName) then begin ShowMessage('File not found:' + FileName ); exit; end;
//  // All Ok
//  TS:= TStringList.Create();
//  TFS:= TTextFileStream.Create(FileName,fmOpenRead);
//  TFSW:= TTextFileStream.Create(ChangeFileExt(FileName,'.exp.csv'),fmCreate);
//  TSW := TStringList.Create();
//  try
//    LineCount := 0;
//    while (not TFS.Eof) do
//    begin
//      inc(LineCount);
//      if ((LineCount mod 10) = 0) then memoInfo.Append('Process line: '+IntToStr(LineCount));
//      OneLine:= TFS.ReadLn;
//      // Skip over line if startline not reached
//      if (LineCount <= StartLine) then
//      begin
//        memoInfo.Append('Skip line: '+IntToStr(LineCount));
//        Continue;
//      end;
//      // If line is empty, we skip this line
//      if OneLine = '' then
//      begin
//        memoInfo.Append('Empty line: '+IntToStr(LineCount) + ' skipping');
//        Continue;
//      end;
//      // Make Hash
//      Hash := LowerCase(MDPrint(MDString(OneLine, MD_VERSION_5)));
////***********
//      //if gListManager.HashList.FindHash(Hash) <> 0 then
//      //begin
//      //  memoInfo.Append('Duplicated line: '+IntToStr(LineCount) + ' skipping');
//      //   Continue;
//      //end;
//
//
//      TS.Clear;
//      TS.Delimiter:=';';
//      TS.DelimitedText := Oneline;
//      TSW.Clear;
//      TSW.Delimiter:=';';
//      gListManager.FilterList.Read;
//
//      memoInfo.Append('O:'+TS.DelimitedText);
//      for aTiObjects in gListManager.FilterList do
//      begin
//        if TFilter(aTiObjects).CheckParams then
//        begin
//          if aTiObjects is TFilterHash then
//          begin
//            TFilterHash(aTiObjects).Params:=Hash;
//          end;
//          if not TFilter(aTiObjects).Execute(TS,TSW) then
//            memoInfo.Append('Execute ' + TFilter(aTiObjects).ClassName + ' failed');;
//          memoInfo.Append(TSW.DelimitedText);
//        end
//        else
//          memoInfo.Append(TFilter(aTiObjects).ClassName + ' failed');
//      end;
//
//      //aHash := THash.CreateNew;
//      //aHash.Hash:=Hash;
//      //aHash.Filename:=FileName;
//      //aHash.StoreDate:=now();
//      //gListManager.HashList.Add(aHash);
//      //gListManager.HashList.Save;
//      // Store Result
//      strTemp := TSW.DelimitedText;
//      if strTemp='' then strTemp :='nothing';
//      TFSW.Write(strTemp[1], Length(strTemp));
//      TFSW.Write(LineEnding, Length(LineEnding));
//    end;
//  finally
//    TS.Free;
//    TSW.Free;
//    TFS.Free;
//    TFSW.Free;
//  end;
//end;
//

function TFormConv.DoLoadConfig:Boolean;
var
  FileName : string;
begin
  //
  FileName := BaseFileName+'_SGFields.txt';
  if FileExists(FileName) then
    begin
      SGFields.LoadFromCSVFile(FileName);
    end
  else
    begin
      // Default Daten einfügen
    end;
  //
  FileName := BaseFileName+'_SGHash.txt';
  if FileExists(FileName) then
    SGHash.LoadFromCSVFile(FileName)
  else
    begin
      // Default Daten einfügen
    end;
  //
  FileName := BaseFileName+'_SGSearch.txt';
  if FileExists(FileName) then
    SGSearch.LoadFromCSVFile(FileName)
  else
    begin
      // Default Daten einfügen
    end;
  Result := true; // default for now
end;

function TFormConv.DoSaveConfig:Boolean;
var
  FileName : string;
begin
  //
  FileName := BaseFileName+'_SGFields.txt';
  SGFields.SaveOptions:=[soDesign,soContent];
  SGFields.SaveToCSVFile(FileName);
  //
  FileName := BaseFileName+'_SGHash.txt';
  SGHash.SaveOptions:=[soDesign,soContent];
  SGHash.SaveToCSVFile(FileName);
  //
  FileName := BaseFileName+'_SGSearch.txt';
  SGSearch.SaveOptions:=[soDesign,soContent];
  SGSearch.SaveToCSVFile(FileName);
  //
  Result := true; // default for now
end;

function TFormConv.FindHash(Hash: String): Integer;
var
  i : integer;
begin
  for i := 0 to SGHash.Cols[1].count - 1 do
    if CompareText(SGHash.Cols[1].ValueFromIndex[i],Hash)=0 then
    begin
      Result := i;
      Exit; //==>
    end;
  Result := -1;
end;

procedure TFormConv.StringGridCompactRows(SG: TStringGrid);
begin
  afhelper.afStringGridCompactRows(SG);
end;


procedure TFormConv.StoreHash(Hash, FileName: string);
var row : Integer;
begin
  row := SGHash.RowCount + 1;
  SGHash.RowCount := row;
  SGHash.Rows[row-1].Add('');
  SGHash.Rows[row-1].Add(Hash);
  SGHash.Rows[row-1].Add(FileName);
end;

end.



