unit uSyncDependencies;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

procedure ConnectToDatabase;
procedure ConnectToDatabase(const lDB: string);
procedure RegisterMappings;
procedure StartLog;


implementation

uses
  tiUtils
  , tiOPFManager
  , tiConstants
  , tiLog
  , tiLogToFile
  , BOM_Filter
  , BOM_Hash
  , BOM_Search
  ;

procedure RegisterMappings;
begin
  // Realy needed ?
  // BOM_Filter.RegisterMappings;
end;

procedure ConnectToDatabase(const lDB: string);
begin
  if not gTIOPFManager.DefaultPerLayer.DatabaseExists(lDB,  'null', 'null') then
  begin
    gTIOPFManager.DefaultPerLayer.CreateDatabase(lDB,  'null', 'null');
  end;
  gTIOPFManager.ConnectDatabase(lDB,  'null', 'null', cTIPersistSqldbSQLite3);
  if not gTIOPFManager.TableExists('Filters') then
  begin
    BOM_Filter.CreateTables;
  end;
  if not gTIOPFManager.TableExists('Hashes') then
  begin
    BOM_Hash.CreateTables;
  end;
  if not gTIOPFManager.TableExists('Search') then
  begin
    BOM_Search.CreateTables;
  end;
end;

procedure ConnectToDatabase;
var
  lDB : string;
begin
  lDB := tiSwapExt(ParamStr(0), 'sq3');
{ TODO 1 -oAndreas -cFinishing : Move the dir of the DB to the App Dir of the OS, not in the programm dir  }
  ConnectToDatabase(lDB);
end;


procedure StartLog;
var
  aFileName : String;
  i : Integer;
  LS : String;
begin
  // Log
  aFileName := tiSwapExt(ParamStr(0),'log');
  gLog.RegisterLog(TtiLogToFile.CreateWithFileName(ExtractFilePath(aFileName),ExtractFileName(aFileName),True));
  gLog.SevToLog :=  [
    lsNormal
    ,lsUserInfo
    ,lsObjCreation
    ,lsVisitor
    ,lsConnectionPool
    ,lsAcceptVisitor
    ,lsQueryTiming
    ,lsDebug
    ,lsWarning
    ,lsError
    ,lsSQL
    ];
  Log('Starting', lsNormal);
  LS := '';
  for i := 0 to GTIOPFManager.PersistenceLayers.Count - 1 do
  begin
    if LS <> '' then
      LS := LS + cLineEnding;
    if Trim(GTIOPFManager.PersistenceLayers.Items[i].DBConnectionPools.DetailsAsString) = '' then
      LS := LS + 'Persistence layer: "'+ GTIOPFManager.PersistenceLayers.Items[i].PersistenceLayerName +
            '" loaded, but not connected to a database.'
    else
      LS := LS + GTIOPFManager.PersistenceLayers.Items[i].DBConnectionPools.DetailsAsString
  end;
  if LS <> '' then
    Log(LS, lsDebug)
  else
    Log('No persistence layers loaded', lsDebug);
end;



end.

