unit DBBasicsTestSetup;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testutils, testregistry, testdecorator
  , checkingbom_TST
  , testcheckingbomsearch_tst
  , TestCheckingBOMHash_TST
  , connection_util
  , tiOPFManager
  ;

type

  { TDBBasicsTestSetup }

  TDBBasicsTestSetup= class(TTestSetup)
  protected
    procedure OneTimeSetup; override;
    procedure OneTimeTearDown; override;
  end;

implementation


{ TDBBasicsTestSetup }

procedure TDBBasicsTestSetup.OneTimeSetup;
begin
  // tiOPFManager.FreeAndNilTIPerMgr;
  DeleteDatabase(mDBConnect.DBPath, mDBConnect.DBHost);
  ConnectToDatabase(mDBConnect.DBPath, mDBConnect.DBHost, mDBConnect.UserName, mDBConnect.Password);
end;

procedure TDBBasicsTestSetup.OneTimeTearDown;
begin
//  DisconnectFromDatabase(mDBConnect.DBPath, mDBConnect.DBHost);
  DeleteDatabase(mDBConnect.DBPath, mDBConnect.DBHost);
end;

initialization
  RegisterTestDecorator(TDBBasicsTestSetup,TTestCheckingBOMSearch);
  RegisterTestDecorator(TDBBasicsTestSetup,TTestCheckingBOMHash);
  RegisterTestDecorator(TDBBasicsTestSetup, TTestCheckingBOM);
end.

